=== debian/changelog ===
f3d (2.2.1+dfsg-2build3) noble; urgency=high

  * No change rebuild against libvtk9.1t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Tue, 09 Apr 2024 22:16:22 +0200

f3d (2.2.1+dfsg-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:55:27 +1100

f3d (2.2.1+dfsg-2build1) noble; urgency=medium

  * No-change rebuild against libocct-data-exchange-7.6t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 21:38:28 +0000

f3d (2.2.1+dfsg-2) unstable; urgency=medium

  * Fix missing atomic library for armel build.

 -- Francois Mazen <mzf@debian.org>  Sun, 15 Oct 2023 20:55:21 +0200

f3d (2.2.1+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Deactivate the lfs check in CMakeLists.txt

 -- Francois Mazen <mzf@debian.org>  Thu, 05 Oct 2023 20:50:28 +0200

f3d (2.1.0+dfsg-2) unstable; urgency=medium

  * Increase autopkgtest tolerance for arm64.

 -- Francois Mazen <francois@mzf.fr>  Thu, 14 Sep 2023 22:16:32 +0200

f3d (2.1.0+dfsg-1) unstable; urgency=medium

  * New upstream version.
  * Remove obsolete quilt patches.
  * Update autopkgtest image references as the upstream changed the
    default behavior. Discussion here:
    https://github.com/f3d-app/f3d/issues/984
  * Bump standard version to 4.6.2
  * Update homepage to the canonial f3D.app uri.
  * Use external cxxopts library.
  * Use external nlohmann-json library.

 -- Francois Mazen <francois@mzf.fr>  Wed, 13 Sep 2023 21:29:31 +0200
